#include <mega16.h>
#include <alcd.h>
#include <delay.h>
#include <stdio.h>

int nilai_sensor = 10;

char *my_itoa(int num, char *str)
{
    if(str == NULL)
    { 
        return NULL;
    }               
    sprintf(str, "%d", num);
    return str;
}

int count;
unsigned char jrk;
unsigned char sensor_jarak (){
    count = 0;
    PORTB.6 = 1;
    delay_us(15);
    PORTB.6 = 0;
    delay_us(2);
    while (PINB.7 == 0){}
    while (PINB.7 == 1){
        count++;     
    }
    jrk = count*0.020242/2;
    return jrk;
}

void main()
{
    PORTB=0xC0;
    DDRB=0x00;
    
    lcd_init(16);
    lcd_gotoxy(3,1);
    lcd_putsf("STIKOM Bali");    
    delay_ms(500);
    lcd_clear();   
   
    while(1)
    {       
         //tugas carikan cara untuk mengubah dari bilangan ke karakter sehingga bisa menampilkan nilai ke LCD
          unsigned char hasil[7];    
          nilai_sensor = sensor_jarak();
          my_itoa(nilai_sensor, hasil);
          lcd_puts(hasil);
          delay_ms(200);    
          lcd_clear(); 
    }
}